//
// BuildIndexWindow.h - the dialog used when in 'background' mode.
//

#include "vgui\Application.h"

#include "vgui\Dialog.h"
#include "vgui\EditBox.h"

#include "vos\DiskFile.h"

#include "VolumeIndexBuilder.h"

class FileIndexWriter;

/**************************************************************************

>	class BuildIndexWindow : public vgui::Dialog

	Author:		Tim Browse
	Date:		28/10/2001

	Purpose:	The dialog window used when the program is running in
				'background' mode and rebuilding the index.

**************************************************************************/

class BuildIndexWindow : public vgui::Dialog
{
	public:
		// Ctor/dtor
		BuildIndexWindow();
		~BuildIndexWindow();

		// Set up the dialog
		virtual void OnInitDialog();

		// Start the index building
		virtual bool OnTimer(vgui::TimerID ID);

		// Handle shutdown
		virtual void OnCancel();

	private:
		void StopIndexing();
		void ShutdownIndexing();

	private:
		// Dialog objects
		vgui::EditBox m_IndexStatus;

		//
		// The objects we use to build the index...
		//

		// The main volume enumerator/indexer
		VolumeIndexBuilder* m_pIndexBuilder;

		// The index writer used by the volume index builder
		FileIndexWriter* m_pIndexFile;
		
		// The raw disk file we store all the index data in.
		vos::DiskFile* m_pIndexDiskFile;
};

