//
// FastFindApp.h
//

#ifndef inc_FastFindApp_h
#define inc_FastFindApp_h

#include "vgui\Application.h"

/**************************************************************************

	class FastFindApp : public vgui::ApplicationDialog

	Author:		Tim Browse

	Date:		2001/10/25

	Purpose:	The main application object for this application.

				See vGUI framework for details.

**************************************************************************/

class FastFindApp : public vgui::ApplicationDialog
{
	public:
		DECLARE_VGUI_MESSAGE_MAP();

	public:
		FastFindApp();

		// Create the dialog for our app
		virtual vgui::Dialog* CreateTheDialog();

		// Set up a proper dialog to use for reporting errors.
		void SetupErrorReporter();

		// Find out where the index file should be stored (according
		// to the application preferences).
		static vos::FileSpec GetIndexFileSpec();
		static vos::FileSpec GetIndexLocationFileSpec();

		// Change the index location
		static void SetIndexLocationFileSpec(const vos::FileSpec& fsNewLocation);

		// Maximum results allowed
		static int GetMaximumResultsAllowed();
		static void SetMaximumResultsAllowed(int cResuts);

	private:
		void ReadPrefs();

		static void ValidateMaxResults();

	private:
		// Location of index file
		static vos::FileSpec s_fsIndexLocation;

		// Maximum number of search results to show at once
		static int s_cMaxResults;
};

//
// Leafname of the index file
//
#define kIndexFile ("fastfind.idx")


#endif // !inc_FastFindApp_h
